function X = compute_statematrix(u, y, esn, nmin)

% Si y est vide, on utilise cette fonction pour tester l'ESN; la sortie 
% renvoye dans l'ESN en feedback est donc celle calcule lors de la propagation 
% (uniquement prise en compte si des poids de rtroaction ont t donns)
% Si y est non vide, on l'utilise lors de la propagation : on appelle a 
% faire du teacherForcing (si les poids de rtroaction ne sont pas nuls...).

if isempty(y)
    teacherForcing = 0;
else
    teacherForcing = 1;
end

%% Remplir la matrice X
X(1,:) = [u(1,:), rand(1, esn.Nx)];
nmax = length(u(:,1));
for i = 2:nmax
X(i,1:esn.Nu) = u(i,:);
X(i,esn.Nu+1:end) = tanh(u(i,:) * esn.Win' + X(i-1, esn.Nu+1:end) * esn.W');  
endfor
X = X(nmin:end, :);
end