function [trained_esn, X] = train_esn(uapp, yapp, esn, nmin)

%% Calculer l'tat d'cho de l'ESN puis entraner l'ESN 
% avec le signal d'apprentissage donner par (uapp,yapp)

X = compute_statematrix(uapp, yapp, esn, nmin) ; 

esn.Wout = atanh(yapp(nmin:end,:))'*X*pinv(esn.lambda*eye(esn.Nu+esn.Nx)+X'*X);

trained_esn = esn;

end