
(* inputs de test *)
let t = 5;;
let n = 5;;
let region_to_points = Array.create t [];;
let t_n = Array.create n 0;; 

let p_tau_k tau k = 
  let rec deltasum k = function
    | [] -> 0
    | n::l -> if t_n.(n) == k then 1+deltasum k l else deltasum k l
  in
  float_of_int (deltasum k region_to_points.(tau)) /. float_of_int (List.length region_to_points.(tau))
;;

#use "datalib.ml" 

let question1_1 tree data =
  let im = Data.image data in
  let init feuille =
    Array.create (List.length im) 0
  in
  let iter karray (_,datae) = 
    let k = List.assoc datae im in
    karray.(k) := karray.(k)+1;
    karray
  in
  let fin karray = 
    let ptmp = ref(0) in
    let ktmp = ref(0) in
    for k = 0 to List.length im do
      if (karray.(k) > !ptmp) then 
	begin
	  ptmp := karray.(k);
	  ktmp := k;
	end;
    done;
    !ktmp
  in
  fold_data data iter tree init fin
;;


