function plot_sequence(teacherSequence, predictedSequence, nPoints, caption)

if nargin == 3
    caption = '' ; 
end

nFigure = figure ;

nDimensions = length(teacherSequence(1,:)) ; 

for iPlot = 1 : nDimensions
    subplot(nDimensions,1,iPlot) ; 
    %%%% set the caption of the figure    
    title(caption);
    hold on ; 
    plot(teacherSequence(1:nPoints, iPlot),'r') ; 
    plot(predictedSequence(1:nPoints, iPlot)) ; 
end
